package hpdos_rdma_offloaded.handler;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

import com.ibm.darpc.DaRPCFuture;

import hpdos_rdma_offloaded.lib.Follower;
import hpdos_rdma_offloaded.lib.Packet;
import hpdos_rdma_offloaded.protocol.*;

public class ReplicationHandler {
    
    public static List<Follower> followers = new ArrayList<>();
    public static ExecutorService executorService = Executors.newFixedThreadPool(10);
    public ReplicationHandler(){}

    public void addFollower(Follower follower){
        followers.add(follower);
    }

    public static void replicateMetadata(Packet packet) throws InterruptedException, ExecutionException{
        Set<Callable<DaRPCFuture<Request, Response>>> callables = new HashSet<>();
        for(Follower follower : NetworkHandler.followers){
            callables.add(()->{
                Request request = new Request();
                Response response = new Response();
                request.setKey(packet.getKey());
                request.setValue(packet.getValue());
                request.setRequestType(packet.getOperationType());
                DaRPCFuture<Request, Response> future = follower.getStream().request(request, response, false);
                return future;
            });
        }
        List<Future<DaRPCFuture<Request, Response>>> futures = executorService.invokeAll(callables);

        for (Future<DaRPCFuture<Request, Response>> future: futures) {
             Response response = future.get().get(); 
        }
    }

}
