package hpdos_rdma_offloaded.protocol;

import java.io.IOException;
import java.nio.ByteBuffer;

import com.ibm.darpc.DaRPCMessage;

public class Response implements DaRPCMessage{
    public static int SERIALIZED_SIZE = 260;
    private int ack;
    public byte[] key;
    public byte[] value;
    
    @Override
    public int write(ByteBuffer buffer) throws IOException 
    {
        // System.out.println("Response write Method");
        buffer.putInt(ack);
        if(ack == AckType.SUCCESS_WITH_VALUE)
        {
            buffer.put(value);
            return 4+value.length;
        }
        return 4;
    }

    @Override
    public void update(ByteBuffer buffer) throws IOException
    {
        // System.out.println("esponse update method");
        ack = buffer.getInt();
        if(ack == AckType.SUCCESS_WITH_VALUE)
        {
            if(value == null || value.length <128)
                value = new byte[128];
            buffer.get(value);
        }
    }

    @Override
    public int size() {
        
        return SERIALIZED_SIZE;
    }
    
    public int getAck(){
        return ack;
    }

    public void setAck(int ack){
        this.ack = ack;
    }

    public byte[] getKey() {
        return key;
    }

    public void setKey(byte[] key) {
        this.key = key;
    }

    public byte[] getValue() {
        return value;
    }

    public void setValue(byte[] value) {
        this.value = value;
    }
}
